/** This is the concrete class representing that the value at this
 * location has been pushed onto the X86 floating-point stack.  There
 * should only be one of these objects created. */

package CodeGen.X86;

import CodeGen.*;

public class X86FloatingPointStack extends Location {
    /** Constructor */
    public X86FloatingPointStack() { }

    /** Return a printable representation of this location */
    public String toString() {
	return "<floating-point stack>";
    }
}
