/** The class for int values computed during evaluation. */

package Evaluator;

import Typechecker.*;
import Helpers.*;

public class IntValue extends Value {
    // the int value
    protected int value;

    // Constructor
    public IntValue(int v) { 
	value = v; 
    }

    // Printing operations
    public String toString() { 
	return Integer.toString(value);
    }

    // Evaluation operations

    /** If the value is an int, return its value, otherwise report
     * an internal error */
    public int getIntValue(int line_number) {
	return value;
    }
}
