/** This is the abstract superclass of all IL (intermediate language)
 * expressions that are unary operators. */

package IL;

import CodeGen.*;
import java.io.*;

public abstract class ILUnopExpr extends ILExpr {
    // Instance variable
    protected ILExpr arg;    // the operand


    // Constructor
    public ILUnopExpr(ILExpr a) {
	arg = a;
    }


    // Printing
    public String toString() {
	return opToString() + " " + arg.toString();
    }
    // return the name of the operator
    protected abstract String opToString();
}
