/** The class for boolean values computed during evaluation. */

package Evaluator;

import Helpers.*;

public class BooleanValue extends Value {
    // the boolean value
    protected boolean value;

    // Constructor
    public BooleanValue(boolean v) { 
	value = v; 
    }

    // Printing operations
    public String toString() { 
	return value ? "true" : "false";
    }

    // Evaluation operations

    /** If the value is a boolean, return its value, otherwise report
     * an internal error */
    public boolean getBooleanValue(int line_number) {
	return value;
    }
}
