/** This is the abstract superclass for all IL (intermediate language)
 * statements */

package IL;

import CodeGen.*;
import java.io.*;

public abstract class ILStmt {
    // Constructor
    public ILStmt() { }


    // Printing
    public abstract String toString();


    // Target code generation operations

    /** generate target code for this statement */
    public abstract void codegen(Target target) throws IOException;
}
