/** This is the abstract superclass of all initializers for IL
 * (intermediate language) global variables */

package IL;

import CodeGen.*;
import java.io.*;

public abstract class ILValue {
    // Constructor
    public ILValue() { }

    // Printing
    public abstract String toString();


    // Target code generation operations

    /** generate code for this initializer */
    public abstract void codegenInitializer(Target target) throws IOException;
}
